#lampHandler.py
import utils
import BluCallbacks
from time import sleep

#Lamp authentication PIN
AUTH_PIN = "72229abba0"

global BRIGHT
TEMP = 2700
BRIGHT = 10

def authenticateConnection(lamp):
    """Performs necessary authentication with lamp"""
    #Connect and immediately authenticate with FLC lamp
    lamp.writeToCharacteristic("2506", AUTH_PIN)
    lamp.writeToCharacteristic("2501","000001")
    sleep(0.4)
    lamp.writeToCharacteristic("2501","001500")


def setBrightness(value, device):
    """Sets lamp brightness, from 0 to 100"""
    global TEMP
    global BRIGHT
    if(value == None):
        value = BRIGHT
    if(value != 0):
        BRIGHT = utils.clamp(value, 0, 100)
        valueC = utils.padded_hex(((BRIGHT*2.55)*(TEMP-2700)/3800), 2)
        valueW = utils.padded_hex(((BRIGHT*2.55)*(3800 - (TEMP-2700))/3800), 2)
        #print(str(valueC)+str(valueW)+"00")
        device.writeToCharacteristic("2501",str(valueC)+str(valueW)+"00")
    else:
        device.writeToCharacteristic("2501","000000")
    

def setTemp(temp, device):
    """Sets lamp temperature. 2700 is warm, 6500 is cold."""
    global TEMP
    global BRIGHT
    
    TEMP = utils.clamp(temp, 2700, 6500)
    setBrightness(BRIGHT, device)