#utils.py
import requests
import json
import struct
import subprocess

def doPostRequest(data, url, keyargs):
    """Do a post request with payload and optional keyargs"""
    try:
        if(keyargs != None):
            resp = requests.post(url, json=json.dumps(data), params=keyargs)
            return resp
        resp = requests.post(url, json=json.dumps(data))
        return resp
    except Exception as ex:
        print("Error: "+ex.message)

def padded_hex(value, pad):
    rounded = int(value)
    return "{0:0{1}x}".format(rounded,pad)

def clamp(n, smallest, largest): 
    return max(smallest, min(n, largest))

def unpackData(data):
    arg = "<"
    length = len(data)
    for i in range (0, length):
        arg = arg + 'B' 
    proc_data = struct.unpack(arg, data)
    return proc_data

def playAudio(file, iswave):
    print("[PlayAudio] Tocando "+file+"...")
    if(iswave):
        subprocess.call(["aplay", file])
    else:
        subprocess.call(["play", "-q", file])