#! /usr/bin/env python
# -*- coding: utf-8 -*-

from bottle import Bottle, request, response, run, hook
from time import sleep
server = Bottle()
import os
import subprocess
import json

#GTTS
from gtts import gTTS

class EnableCors(object):
    name = 'enable_cors'
    api = 2

    def apply(self, fn, context):
        def _enable_cors(*args, **kwargs):
            # set CORS headers
            response.headers['Access-Control-Allow-Origin'] = '*'
            response.headers['Access-Control-Allow-Methods'] = 'GET, POST, PUT, OPTIONS'
            response.headers['Access-Control-Allow-Headers'] = 'Origin, Accept, Content-Type, X-Requested-With, X-CSRF-Token'

            if request.method != 'OPTIONS':
                # actual request; reply with the actual response
                return fn(*args, **kwargs)

        return _enable_cors

def allow_cors(func):
    def wrapper(*args, **kwargs):
        response.headers['Access-Control-Allow-Origin'] = '*'
        response.headers['Access-Control-Allow-Methods'] = 'PUT, GET, POST, DELETE, OPTIONS'
        response.headers['Access-Control-Allow-Headers'] = 'Origin, Accept, Content-Type, X-Requested-With, X-CSRF-Token'

        return func(*args, **kwargs)
    return wrapper

@hook('after_request')
def enable_cors():
    response.headers['Access-Control-Allow-Methods'] = 'PUT, GET, POST, DELETE, OPTIONS'
    response.headers['Access-Control-Allow-Headers'] = 'Origin, Accept, Content-Type, X-Requested-With, X-CSRF-Token'
    response.headers['Access-Control-Allow-Origin'] = '*'

@server.route('/getIp', method=['GET'])
@allow_cors
def getIp():
    print("[Hotspot] Retrieving IP address")
    cmd = r"ip route get 8.8.8.8 | sed -nr 's/.*dev ([^\ ]+).*/\1/p'"
    interface = subprocess.check_output(str(cmd), shell=True)
    interface = interface[:-1]
    print("[Hotspot] Interface: " + str(interface))
    if interface == "":
        interface = "wlan0"
    cmd2 = 'sudo ifconfig ' + str(interface) + ' | grep "inet" | cut -f2 -d":" | tr -d [a-zA-Z] | grep -v "214" | cut -c10- | cut -d " " -f1-1'
    ip = subprocess.check_output(str(cmd2), shell=True).strip('\n')
    print("[Hotspot] IP address: " + str(ip))
    if "127.0.0.1" in ip:
        print("[Hotspot] Connection is Hotspot")
        ip = ip.replace("127.0.0.1", "").strip()
    response.headers['Content-Type'] = "application/json"
    #os.system("gtts-cli "+ip+" --lang pt-br --output ip.mp3")
    #subprocess.call(["play", "ip.mp3"])
    return json.dumps({'ip': ip})

@server.route('/getSSID', method=['GET'])
@allow_cors
def getSSID():
    response.headers['Content-Type'] = "application/json"
    print("[Hotspot] Retrieving SSID")
    cmd = r"ip route get 8.8.8.8 | sed -nr 's/.*dev ([^\ ]+).*/\1/p'"
    interface = subprocess.check_output(str(cmd), shell=True)
    interface = interface[:-1]
    print("[Hotspot] Interface: " + str(interface))
    if interface == "":
        connected_ssid = "MODO HOTSPOT"
    else:
        try:
            connected_ssid = subprocess.check_output("sudo iwgetid -r", shell=True)
            connected_ssid = connected_ssid[:-1]
        except:
            connected_ssid = "Ethernet"

    return json.dumps({'ssid': connected_ssid})

@server.route('/setNetwork', method=['POST', 'OPTIONS'])
@allow_cors
def setNetwork():
    print(request.json)
    print("[setup] Received network information data.")
    print("[setup] -> SSID: "+request.json['ssid'])
    print("[setup] -> Password: "+request.json['password'])
    print("[setup] -> Security: "+request.json['security'])
    print("Connecting to network...")
    os.system("bash /home/linaro/google_coffee_machine_demo/DB/hotspot_service/nwk_setup.sh "+request.json['password']+" "+request.json['ssid']+" "+request.json['security'])
    return "Ok"

@server.route('/setHotspot', method=['GET', 'POST'])
@allow_cors
def setHotspot():
    print("[setup] Received request to start hotspot.")
    os.system("bash hotspot_setup.sh")

def main():
    print("Hotspot service execution started.")

    server.install(EnableCors())

    #Run server listener
    server.run(host='0.0.0.0', port=3000)

    #Loop forever
    while True:
        sleep(5)


if __name__ == "__main__":
    main()
