#! /usr/bin/env python
# -*- coding: utf-8 -*-

import os
import subprocess
from bs4 import BeautifulSoup
import paho.mqtt.client as mqtt
import time

# Callback de conexão do MQTT.
def on_connect(client, data, flags, rc):
    print("[DB Info] Successfully connected to MQTT Broker!")

# Configuração do MQTT.
client = mqtt.Client()
client.username_pw_set("jxjsnxmg", "udFaxAHvuCyI")

try:
    client.connect("m16.cloudmqtt.com", 19011, 60)
    client.on_connect = on_connect

    while True:

        # Coloca os dados do GPS num arquivo de log e transforma ele em objeto no Python.
        test = os.system('timeout 2s gpxlogger > log.txt')
        path = os.getcwd() + "/log.txt"
        soup = BeautifulSoup(open(path), "html.parser")
        
        try:
            # Pega os dados de Latitude e Longitude de acordo com os parâmetros do arquivo.
            lat = soup.find_all("trkpt")[0]['lat']
            lon = soup.find_all("trkpt")[0]['lon']
            client.publish('db/localization', lat + "/" + lon, retain=True)
            time.sleep(1)

        except (IndexError):
            print("[DB Info] It was not possible to get GPS information.")
            client.publish('db/localization', "Não foi possível obter a localização do equipamento.", retain=True)
            time.sleep(1)

        public_ip = subprocess.check_output("curl http://ifconfig.me/ip", shell=True)
        local_ip = subprocess.check_output("hostname -I", shell=True)

        try:
            connected_ssid = subprocess.check_output("sudo iwgetid -r", shell=True)
            connected_ssid = connected_ssid[:-1]
            
            wifi_interface = subprocess.check_output("sudo iwgetid | cut -f1 -d ' '", shell=True)
            wifi_interface = wifi_interface[:-1]

            wifi_signal_strength = subprocess.check_output("sudo iwconfig " + wifi_interface + " | grep Quality | cut -d'=' -f2 | cut -d' ' -f1", shell=True)
            wifi_signal_strength = wifi_signal_strength[:-1]

            split = wifi_signal_strength.split("/")
            wifi_signal_strength = str(int(((float(split[0]) / float(split[1]))*100))) + "%"

            local_ip = local_ip.split(" ")[0]

        except:
            connected_ssid = "Ethernet"
            wifi_signal_strength = "100%"        
            local_ip = local_ip.split(" ")[1]
                
        if local_ip != 0:
            client.publish('db/ip/local', str(local_ip), retain=True)
        else:
            client.publish('db/ip/local', "Não foi possível obter o IP Local.", retain=True)
        time.sleep(1)

        if public_ip != 0:
            client.publish('db/ip/public', str(public_ip), retain=True)
        else:
            client.publish('db/ip/public', "Não foi possível obter o IP Público.", retain=True)
        time.sleep(1)

        if connected_ssid != "--":
            client.publish('db/wifi/ssid', str(connected_ssid), retain=True)
        else:
            client.publish('db/wifi/ssid', "Nenhum Wi-Fi conectado!", retain=True)
        time.sleep(1)

        client.publish('db/wifi/signal_strength', wifi_signal_strength, retain=True)
        print("[DB Info] Info sent!")
        time.sleep(5)

except:
    print("[DB Info] It was not possible to connect to MQTT Broker.")