#Syswatch quickdoc
Author: Pedro Polez

This quick document describes basic functionality of the Syswatch software. The main goal of this application is to run and safeguard user specified jobs, restarting these in case they crash or doing other related application cleanup before rebooting it, or even rebooting the whole OS.

###JSON file structure
Jobs are defined as .json files, located in the "jobs" subfolder. JSON parameters are:
```JSON
{
    "name": "New service",
    "path": "/absolute/path/to/software.py",
    "cmd": "python",
    "restart": true, 
    "container": false
}
```
* name: Defines the job name.
* path: Must point to file to be run, full filepath required.
* cmd: Command that runs the file defined above.
* restart: True if service should be restarted on crash.
* container: Runs specified job in a separate "screen" session, allowing user to attach to it and interact with command line.  

###Depends
All dependencies must be installed with ```sudo pip install``` prior to first run
* tailer
* screenutils
* AWSIoTPythonSDK
* coloredlogs

---
##Notes
* Logging is inconsistent for now.
* The "container" parameter is experimental, and **not** suitable for usage yet!
* Defining a "shebang" on top of your file and setting cmd to ```"."``` **won't work.**

##TODO: Tower specific
* Bluetooth does not attempt to start csrMeshGwApp if it's not running, which makes it restart-crash forever