#jobcontroller.py
#Handles job loading from disk, job execution and cleanup

from logging.handlers import RotatingFileHandler
import logging
import json
from threading import Thread
import os
import subprocess
from time import sleep
#from screenutils import list_screens, Screen
import tailer
import utils
from jobs import Job

def loadJobs():
    print("[JobCtl] Loading applications to monitor...")
    jobQueue = list()
    for jobfile in os.listdir("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/jobs"):
        if(jobfile.endswith(".json")):
            #Read job information from json
            jfile = open("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/jobs/"+jobfile, "r")
            jstats = json.loads(jfile.readline())

            njob = Job()
            njob.name = jstats['name']
            njob.path = jstats['path']
            njob.cmd = jstats['cmd']
            njob.restart = jstats['restart']
            njob.container = jstats['container']
            if 'restartcmd' in jstats:
                njob.restartcmd = jstats['restartcmd']
            print("Added job: "+njob.name)
            jobQueue.append(njob)
    print("[JobCtl] All jobs parsed!")
    return jobQueue

def runJobs(jobqueue):
    #TODO: Use pip's screenutils for managing screen sessions more painlessly
    print("[JobCtl] Starting jobs")
    for task in jobqueue:
        runSingleJob(task, False)
    sleep(0.2)
    print("[JobCtl] Done.")

def runSingleJob(job, restarting):
    if(restarting):
        if(job.restartcmd != None):
            print("Running job pre-run cmd: "+job.restartcmd)
            os.system(job.restartcmd)
    
    if(job.container == True):
        if(job.process == None):
            job.process = Screen(job.name.replace(" ", ""), True)
        job.process.send_commands(job.cmd+" "+job.path)
        print("screen session exec: "+job.cmd+" "+job.path)
    else:
        print("exec: "+job.cmd+" "+job.path)

        #Log wrapper
        #if(job.log == None):
        #    createLogger(job)
        #   job.log.debug("Execution for task ["+job.name+"] begins =-=-=-=-=-=-=-=-=-=-=")

        job.log = open("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/logs/"+job.name.replace(" ", "")+".log", 'w')
        #job.process = subprocess.Popen([job.cmd+" "+job.path], shell=True, stdout= open("/dev/null", "a"), stderr=job.log)
        job.process = subprocess.Popen([job.cmd+" "+job.path], shell=True, stderr=job.log)

    sleep(0.1)
    return job

def getLastLog(job, n):
    try:
        return '\n'.join(tailer.tail(job.log, n))
    except Exception as er:
        read = open("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/logs/"+job.name.replace(" ", "")+".log")
        return '\n'.join(tailer.tail(read, n))

#Unused
def createLogger(job):
    #Setup logger for a task
    _tmp = open("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/logs/"+job.name.replace(" ", "")+".log", 'w')
    _tmp.close()
    nhandler = RotatingFileHandler("/home/linaro/google_coffee_machine_demo/DB/syswatch_dev/logs/"+job.name.replace(" ", "")+".log", 'w', 600000, 1)
    job.log = logging.getLogger(job.name.replace(" ", "")).addHandler(nhandler)
    job.log = logging.getLogger(job.name.replace(" ", "")).setLevel(logging.DEBUG)
    job.log = logging.getLogger((job.name.replace(" ", "")))
    job._reader = Thread(target=streamReader, args=([job]))
    job._reader.setDaemon(True)
    job._reader.start() 

#Unused
def streamReader(job):
    line_count = 0
    while True:
        #Read stream and write to log
        if(job.process != None):
            if(job.process.poll() != None):
                return False
            line = job.process.stdout.readline()
            if(line != ""):
                job.log.debug('%s', line.strip())
                print("Line logged.")
                line_count = line_count + 1
                if(line_count > 200):
                    job.process.stdout.flush()
                    print("Flush STDOUT.")
                    line_count = 0
        sleep(0.2)
