from app import app
from flask import Flask, render_template, request, flash
import pubsub
from flask_cors import CORS, cross_origin
import json
import time
import datetime

pubsub.SubTopics()

@app.route("/index")
@app.route("/")
def index():
    if request.user_agent.platform == "iphone" or request.user_agent.platform == "android":
        return render_template('index_mobile.html')
    else:
        return render_template('index.html')

@app.route("/lamp")
def lamp():
    return render_template('lamp.html')

@app.route("/lamp/<status>", methods=['POST', 'GET'])
def lamp_status(status):
    if request.method == "POST":
        if status == "lampOn":
            pubsub.turnOnMainLamp()
        elif status == "lampOff":
            pubsub.turnOffMainLamp()
        return "OK"
    else:
        status = pubsub.getMainLampStatus()
        print("Lamp Status: " + str(status))
        return str(status)

@app.route("/coffee_machine")
def coffee_machine():
    return render_template('coffee_machine.html')

@app.route("/coffee_machine/<status>", methods=['POST', 'GET'])
def coffee_machine_status(status):
    if request.method == "POST":
        stats = json.loads(pubsub.getCoffeeMachineStatus())
        
        if status == "coffeeOn":
            pubsub.turnOnCoffeeMachine()
            return 'OK'
        elif status == "coffeeOff":
            pubsub.turnOffCoffeeMachine()
            return 'OK'

        #Check coffee machine state
        if stats['isOn'] == False:
            return "isOff"
        elif stats['waterLevel'] == False:
            return "NoWater"
        elif stats['hasGlass'] == False:
            return "NoGlass"
        elif stats['busy'] == True:
            return "Busy"
        elif stats['coffeeLevel'] < 50:
            return "LowCoffee"

        if status == "longCoffee":
            pubsub.makeLongCoffee()
        elif status == "shortCoffee":
            pubsub.makeShortCoffee()
        return "OK"
    else:
        cmStatus = pubsub.getCoffeeMachineStatus()
        return str(cmStatus)

@app.route("/internet_settings")
@cross_origin(supports_credentials=True)
def internet_settings():
    return render_template('internet_settings.html')